<template>
    <div>
        <h1 v-if="id">Modification leçon</h1>

        <div class="uk-margin">
            <input
                class="uk-input"
                type="text"
                placeholder="Titre"
                v-model="titre"
            />
        </div>
        <div>
            <span class="uk-flex">
                Privé
                <input class="uk-checkbox" type="checkbox" v-model="prive" />
            </span>
        </div>
        <EditeurTexte v-model="texte" v-if="texte" />
        <button class="uk-button uk-button-default" @click="envoyer">
            Enregistrer
        </button>
        <button class="uk-button uk-button-default" @click="$router.go(-1)">
            Retour
        </button>
    </div>
</template>

<script lang="ts">
import Vue from 'vue';
import Component from 'vue-class-component';
import EditeurTexte from '@/components/EditeurTexte.vue';
import Axios from '@/auth/axiosAuth';

@Component({
    components: { EditeurTexte }
})
export default class ModificationLecon extends Vue {
    private id = '';
    private texte = '';
    private titre = '';
    private prive = false;

    beforeRouteEnter(to, from, next) {
        next(vm => {
            const formData = new FormData();
            formData.append('id', to.params.id);
            formData.append('idClub', vm.$auth.user.idClub);
            if (to.name == 'ModificationLecon') {
                Axios.post(
                    'lecon/',
                    response => {
                        const lecon = response.data;
                        vm.titre = lecon.titre;
                        vm.niveau = lecon.niveau;
                        vm.texte = lecon.texte;
                        vm.prive = lecon.prive;
                        vm.id = to.params.id;
                    },
                    formData
                );
            } else {
                vm.texte = 'Ecrire la leçon ici';
            }
        });
    }

    public envoyer() {
        const formData = new FormData();
        formData.append('titre', this.titre);
        formData.append('texte', this.texte);
        formData.append('idCreateur', this.$auth.user.id);
        formData.append('prive', JSON.stringify(this.prive));
        if (this.id) {
            Axios.put(
                'lecon/' + this.id,
                response => this.allerAVisualisation(response.data.id),
                formData
            );
        } else {
            Axios.post(
                'lecon/creation/',
                response => this.allerAVisualisation(response.data.id),
                formData
            );
        }
    }

    private allerAVisualisation(idResponse) {
        this.$router.push({
            name: 'VisualisationLecon',
            params: { id: idResponse }
        });
    }
}
</script>
